function [u,U,I,J]=xunique(x,opt)
%function [u,U,I,J]=xunique(x,opt)
%[u,I,J]=unique(x);
%U(i) gives multiplicity of u(i)
%
%EXPERIMENTAL:
%[u,I,J]=unique(x,'rows');
%U(i) gives multiplicity of u(i)

if isempty(x)
	[u,U,I,J]=deal([],[],[],[]);
	return
end

if nargin<2
	[u,I,J]=unique(x);		%most awesome lines of code
	o=ones(size(x));      %most awesome lines of code
	U=full(sparse(o,J,o));%most awesome lines of code
else
	switch opt
	case 'freq'
		
		[u,I,J]=unique(x);
		o=ones(size(x));
		U=full(sparse(o,J,o));
		[sU,si]=sort(-U);
		tmp(si)=1:length(si);
		[u,U,I,J]=deal(u(si),-sU,I(si),tmp(J));
	otherwise
		sx=size(x);
		x=fliplr(x);
		[x,I]=unique(x,'rows');
		for c1=flipud(find(isnan(x(:,1))))'
			f=find(~isnan(x(c1,:)));
			f=f(1); %!!!
			g=find(all(x(1:c1-1,f:end)==repmat(x(c1,f:end),[c1-1 1]),2));
			if ~isempty(g);
				x(c1,:)=[];
				I(c1)  =[];
			end
		end
		u=fliplr(x);
		[u,uI]=sortrows(u);
		I=I(uI);
		%[I,sI]=sort(I);
		%u=u(sI,:);
		U='has no meaning';
		J='has no meaning';
	end
end
